//Steve is responsible for this as well

#include <vector>
#include <stdexcept>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/mman.h>
#include "multidimensionalarray.h"
#include <string>
#include <fstream>
#include <cassert>
#include <sstream>
#include <iostream>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include "fileutil.h"
#include <list>

using namespace std;

template<class DataType>
class BucketData; 
template<class DataType>
class BucketIterator; 

template<class DataType>
class Bucket{


    public:
            /*****
             * ALWAYS INITIALIZE all variables in C++, especially
             * the pointers. Having pointers that point to random
             * location in memory is insane!!!!!!!!!!
             */
    Bucket():mNumberOfDimensions(0), mBucketSize(0),mIndex(0), mDepth(0),
data(0), hash(0),numItems(0),next(0),
mFileDescriptor(0),mData(0),mData2(0),mFileName(),
             mBaseFileName()
// pointer to data
 {cerr<<"BUCKET Oh Oh, default constructor called! "<<endl;}

/*    Bucket(Bucket & b):data(b.data){
	this->numItems = b.numItems;
	this->hash = b.hash;
	this->mBucketSize = b.mBucketSize;
	this->mNumberOfDimensions = b.mNumberOfDimensions;
	this->next = b.next;
	}*/
    Bucket(const Bucket<DataType> & other) {
            cerr << "BUCKET COPY CONSTRUCTOR!!! SILLY ME! NOT IMPLEMENTED!!!"<<endl;
    }

    /**
     * Always initialize variables using the notation below. It is
     * safer, faster.
     */
    Bucket(int numDimensions, int size, int h, int index, string file, int depth = 0): mNumberOfDimensions(numDimensions), mBucketSize(size),mIndex(index), mDepth(depth),
data(vector<BucketData<DataType> >(0)), hash(h),numItems(0),next(0), mFileDescriptor(0),mData(0),mData2(0),mFileName(), mBaseFileName()
{
//	cout << "Bucket Constructor 3" << endl;
	stringstream s;
	s << file << "-" <<this->mIndex << "-" << this->mDepth;
	this->mFileName = s.str();
	this->mBaseFileName = file;
	this->open();
    }

    ~Bucket(){this->close();}

    inline int getHash() const {return hash;}

    inline int getNumItems() const {
            cout <<" getNumItems "<<endl;
            cout << mData2[0] << endl;
            cout <<" getNumItems ok"<<endl;
            if(mData2 == 0) {cerr << "This will crash, you haven't called open yet! (default constructor?)"<<endl;}
            return mData2[0];}

    inline int getSize() const {return mBucketSize;}

    inline Bucket* getNext() const{return next;}

    void open() throw(std::ifstream::failure);

    void close();

    void blankFile();

    bool insert(vector<int> key, DataType val);

    DataType get(const vector<int>& key) const;

    bool undefinedAt(const vector<int>& key) const;

    BucketData<DataType> get(int i) const;


    BucketIterator<DataType>* iterator() const {return new BucketIterator<DataType>(this);}

 protected:
    int mNumberOfDimensions;
    int mBucketSize;
    int mIndex, mDepth;
    vector<BucketData<DataType> > data;
    int hash;
    int numItems;
    Bucket *next;

    int mFileDescriptor; //file descriptor
    DataType *mData;// pointer to data
    int *mData2;// pointer to data
    
    string mFileName, mBaseFileName;

    enum {verbose = 0};

    inline DataType fastget(const int64  pos) const {
	return mData[pos];
    }

    inline uint64 getVolume(){
	return (sizeof(int) + (sizeof(int) * this->mNumberOfDimensions + sizeof(DataType)) * this->mBucketSize);
    }


    friend class BucketData<DataType>; 
    friend class BucketIterator<DataType>; 
    
};

template<class DataType>
void Bucket<DataType>::open() throw(std::ifstream::failure){
    cout << "[Bucket] opening... "<<endl;
    assert (mData == 0);
    assert (mData2 == 0);
    //copied from bigarray.h directly
    //do I completely understand it... not even close!
    
    FileUtil::mkdir_parentsonly(mFileName.c_str());
    if(!FileUtil::fileExists(mFileName.c_str()) || 
      (FileUtil::getFileSize(mFileName.c_str()) != this->getVolume())){
    // make sure the path the file exists
    //                
    const char * path = mFileName.c_str();
    char * shorter_path = strdup(path);
    char * p = strrchr(shorter_path, '/');// find the last occurance of '/'
    if(p == 0 || p == path) free(shorter_path);
    else {
      p[0] = 0;// set blank
      if(verbose) cout << "Creating directory "<<shorter_path << endl;
      int returnvalue = FileUtil::mkdir_parents(shorter_path);// should check return value
      if(verbose) cout << " Return value = " << returnvalue << endl;
      free(shorter_path);
    }
    // create the file
    blankFile();

  }
  FileUtil::mkdir_parentsonly(mFileName.c_str());
  mFileDescriptor = ::open(mFileName.c_str(), O_RDWR | O_CREAT);
  if(mFileDescriptor == -1 ) {
      stringstream strs;
      strs << "Failed to open file "<< mFileName<< " in R/W mode error code is " << errno<< " (see errno.h)";
      //string errormsg;
      //strs >>  errormsg ; 
      throw ifstream::failure(strs.str());
  }
  // I strongly suspect that if the volume is too big, the next line will fail
  // For now, just make the code fail until someone can check this out
  //if((uint64) (uint) (sizeof(DataType)* (this->getVolume())) != (sizeof(DataType)*(this->getVolume())))
  //    throw length_error("bigarray_open");
  mData = (DataType *)mmap((caddr_t)0, this->getVolume(), 
			   PROT_READ | PROT_WRITE, MAP_SHARED, mFileDescriptor, 0);
  mData2 = (int *)mmap((caddr_t)0, this->getVolume(), 
			   PROT_READ | PROT_WRITE, MAP_SHARED, mFileDescriptor, 0);
  cout << "[Bucket] mData and mData2 are mapped! "<<endl;
  cout <<"volume = "<<this->getVolume() <<endl;
  if ( mData == MAP_FAILED) {
      stringstream strs;
      strs << "Failed to map file "<< mFileName<< " error code is " << errno<< " (see errno.h)";
      //string errormsg;
      //strs >>  errormsg ; 
      throw ifstream::failure(strs.str());
  }
  if ( mData2 == MAP_FAILED) {
      stringstream strs;
      strs << "Failed to map file "<< mFileName<< " error code is " << errno<< " (see errno.h)";
      //string errormsg;
      //strs >>  errormsg ; 
      throw ifstream::failure(strs.str());
  }
 
  //temporary... this shouldn't be here later
  numItems = this->getNumItems();
  cout << "got numItems" << endl;

  if(this->getNumItems() > this->mBucketSize){
      next = new Bucket(this->mNumberOfDimensions, this->mBucketSize, this->hash, this->mIndex, this->mBaseFileName, this->mDepth+1);
      
  }


}

template<class DataType>
void Bucket<DataType>::close(){
  cout << "UNMAPPING!!!!!!!!!!!!!!!"<<mFileName <<endl;
  if (mData != NULL)  {
    munmap(mData, this->getVolume());
    munmap(mData2, this->getVolume());
    mData = NULL;
    mData2 = NULL;
    ::close(mFileDescriptor);
  }
}

template <class DataType>
void Bucket<DataType>::blankFile() {
    //cout << " blanking the file " << endl;
    int * key = new int[this->mNumberOfDimensions];
    DataType * val = new DataType[1];
    memset(key,0,this->mNumberOfDimensions * sizeof(int));
    memset(val,0,sizeof(DataType));
    
    if(verbose) cout << "Blanking "<<mFileName << endl;
    ofstream FileStream( mFileName.c_str(),std::ios::binary |  std::ios::trunc);
    if(!FileStream.is_open()) {
	cout << " I could not create/write to " << mFileName << endl;
    }
    assert(FileStream.is_open());
    assert(!FileStream.fail());
    //FileStream.seekp(0);
    FileStream.write((char *) key, sizeof(int));
    for(int times = 0; times < mBucketSize; ++times){
	FileStream.write((char *) key,this->mNumberOfDimensions * sizeof(int));
	FileStream.write((char *) val,sizeof(DataType));	
    }
    assert(! FileStream.fail());
    FileStream.close();
    delete[] key;
    delete val;
}

template<class DataType>
bool Bucket<DataType>::insert(vector<int> key, DataType val){
    BucketData<DataType> insertMe = BucketData<DataType>(key,val);
    uint i = 0;
    for(i = 0; i < data.size(); i++){
	if(key == data[i].getKey()){
	    data[i] = insertMe;
	    return false;
	}
    }
    
    if(this->numItems >= this->mBucketSize){
	if(this->next == 0) this->next = new Bucket(this->mNumberOfDimensions, this->mBucketSize, this->hash, this->mIndex, this->mBaseFileName, this->mDepth+1);
	bool ret = next->insert(key,val);
	if(ret) this->numItems++;
	return ret;
    }else{
	this->data.push_back(insertMe);
//	cout << "Inserted " << this->data.size() << endl;
	this->numItems++;
	return true;
    }

//    return true; //unnecessary
}

template<class DataType>
DataType Bucket<DataType>::get(const vector<int>& key) const{
//    cout<< "size of data at beginning of get method " << data.size() << endl;
    for(uint i = 0; i < this->data.size() ; i++){
//	cout << key[0] << ", " << key[1] << endl;
	if(key == this->data[i].getKey()){
	    return this->data[i].getValue();
	}
    }
    if(this->next != 0) return next->get(key);
    return 0;
}

template<class DataType>
bool Bucket<DataType>::undefinedAt(const vector<int>& key) const{
    for(uint i = 0; i < this->data.size(); i++){
	if(key == this->data[i].getKey()){
	    return false;
	}
    }
    if(this->next != 0) return next->undefinedAt(key);
    return true;
}

template<class DataType>
BucketData<DataType> Bucket<DataType>::get(int i) const{
    if(i < this->mBucketSize){
	return this->data[i];
    }
    else{
	return next->get(i-mBucketSize);
    }
}

template<class DataType>
class BucketData{
 public:
    BucketData():key(0),value(0){;}

    BucketData(vector<int>& x, DataType y): key(x), value(y){;}

    inline vector<int> getKey() const {return key;}
    inline int getKey(int i) const {return key[i];}
    inline DataType getValue() const {return value;}
    
    bool operator == (BucketData b2){	
	vector<int> key2 = b2.getKey();
	if(this->key.size() != key2.size()) return false;
	for(uint i = 0; i < this->key.size(); i++){
	    if(this->key[i] != key2[i]) return false;
	}
	return true;
    }
 private:
    vector<int> key;
    DataType value;
};

template<class DataType>
class BucketIterator{
 public:
    BucketIterator(const Bucket<DataType> *b):data(b){
	this->count = -1;
	
};
    
    inline DataType val() const {return data->get(count).getValue();}
    inline vector<int> key() {return data->get(count).getKey();}
    inline int key(int i) {return data->get(count).getKey(i);}

    inline bool next(){
	cout << "count = " << count << endl;
	count++;
	int ni = data->getNumItems();
	cout << "ni = " << ni << endl;
	if(count >= ni)
	    return false;
	if(count == data->getSize()){
	    data = data->getNext(); 
	    count = 0;
	}
	return true;	
}

 protected:

 private:
    const Bucket<DataType> *data;
    int count;
};
