#include <pqxx/pqxx>
#include <pqxx/connection>
#include <pqxx/tablewriter>
#include <pqxx/transaction>
#include <pqxx/result>
#include <string>
#include <fstream>
#include <cassert>
#include <sstream>
#include <iostream>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include "fileutil.h"

using namespace std;
using namespace PGSTD;
using namespace pqxx;

template<class DataType>
class BulkWriter{

 public:
    BulkWriter(string tablename):C("dbname=lemur user=steve"), wrk(0),tw(0){
	mTableName = tablename;
	setRate(1000);
	num=0;
    }
    ~BulkWriter(){deleteBulkWriter();}

    void getBulkWriter(){
	if(!tw && !wrk){
	    wrk = new work(this->C,"bulkwriter.h");
	    tw = new tablewriter(*wrk,mTableName);
	    
	}
    } 
    
    void deleteBulkWriter(){
	if(tw){
	    delete tw;
	    wrk->commit();
	    delete wrk;
	    tw = 0;
	    wrk = 0;
	}
    }

    void setRate(int x){rate = x;}

    int getRate(){return rate;}

    int getNum(){return num;}

    void insert(const vector<int> key, const DataType value, const int numDims){
	vector<string> val(numDims + 1);
	for(int i = 0; i < numDims; i++){
	    stringstream s;
	    s << key[i];
	    val[i] = s.str();
	}
	stringstream s;
	s << value;
	val[val.size()-1] = s.str();
	tw->insert(val);
	num++;
	if(num==rate){
	    this->commit();
	}
    }

    void insert(const int key[],const DataType value,const int numDims){
	vector<string> val(numDims + 1);
	for(int i = 0; i < numDims; i++){
	    stringstream s;
	    s << key[i];
	    val[i] = s.str();
	}
	stringstream s;
	s << value;
	val[val.size()-1] = s.str();
	tw->insert(val);
	num++;
	if(num==rate){
	    this->commit();
	}
    }
    
    void commit(){
	deleteBulkWriter();
	num=0;
	this->getBulkWriter();
    }
 protected:
    string mTableName;
    lazyconnection C;
    work * wrk;
    tablewriter * tw;
    int rate;
    int num;
};

