#include "psqlcube.h"
#include "hint.h"
#include "bigarray.h"
#include "internalbigarray.h"
#include "btreecube.h"
#include "btreecube_rotated.h"
#include "cdbcube.h"
#include <time.h>
#include <cmath>
#include <stdlib.h>
int main() {
//  ::unlink("stevetest.bin");
  cout << "Here is a test." << endl;
  int numDims = 4;

  PostgreSQLCube<int> cube(numDims, "postgrestest");
  cube.fillWithZeros();

  vector<int> pos(4);
  pos[0] = 0;
  pos[1] = 0;
  pos[2] = 0;
  pos[3] = 0;

  cube.put(pos,4);
  cube.put(pos,4);
  pos[0] = 1;
  cube.put(pos,5);
  pos[1] = 1;
  cube.put(pos,6);
  pos[2] = 1;
  cube.put(pos,7);
  pos[3] = 1;
  cube.put(pos,8);

  int pos2[4];
  pos2[0] = 0;
  pos2[1] = 0;
  pos2[2] = 0;
  pos2[3] = 0;

  cube.put(pos2,1);

  cout << "Getting pos " << cube.get(pos) << endl;
  cout << "Getting pos2 " << cube.get(pos2) << endl;

  cout <<"Number of records " << cube.getNumberOfRecords() << endl;

  vector<int> pos3(4);
  pos[0] = 1;
  pos[1] = 1;
  pos[2] = 1;
  pos[3] = 1;
  
  cube.printData();
  
  MultidimensionalArray<int>* sliced= cube.slice(0, 1,"slicepostgrestest");  
  sliced->printData();
  sliced->fillWithZeros();
  sliced->close();
  cout<<"getting here"<<endl;
  
  MultidimensionalArray<int>* diced= cube.slice(2, 0,"dicepostgrestest");  
  diced->printData();
  diced->fillWithZeros();
  diced->close();
  
  cube.fillWithZeros();
  
  cout<<"getting here too"<<endl;
  if(cube.undefinedAt(pos)) cout<< "Undefined function works on vector<int>." << endl;
  if(cube.undefinedAt(pos2)) cout<< "Undefined function works on int[]." << endl;
  
  
  cube.close();
}

